
#undef BUILDING_AQDATABASE


#include <aqdatabase/aqdb.h>
#include <aqdatabase/aqdb_db.h>
#include <aqdatabase/aqdb_value.h>

#include <gwenhywfar/gwenhywfar.h>
#include <gwenhywfar/cgui.h>
#include <gwenhywfar/debug.h>

#include <unistd.h>


#include "test1.h"
#include "test2.h"
#include "test3.h"
#include "test4.h"












int main(int argc, char **argv) {
  int rv;
  GWEN_GUI *gui;
  const char *command="test4";
  const char *databaseUrl="file:///tmp/aqdatabase-db1.db";

  rv=GWEN_Init();
  if (rv) {
    DBG_ERROR_ERR(0, rv);
    return rv;
  }

  rv=AQDB_Init();
  if (rv) {
    DBG_ERROR_ERR(0, rv);
    return rv;
  }

  gui=GWEN_Gui_CGui_new();
  GWEN_Gui_SetCharSet(gui, "ISO-8859-15");
  GWEN_Gui_SetGui(gui);
  GWEN_Logger_SetLevel(AQDB_LOGDOMAIN, GWEN_LoggerLevel_Info);

  if (argc>1)
    command=argv[1];
  if (argc>2)
    databaseUrl=argv[2];

  if (strcasecmp(command, "test1")==0)
    rv=test_create_objects(databaseUrl, NULL, NULL);
  else if (strcasecmp(command, "test2")==0)
    rv=test_create_multi(databaseUrl, NULL, NULL);
  else if (strcasecmp(command, "test3")==0)
    rv=test_rollback(databaseUrl, NULL, NULL);
  else if (strcasecmp(command, "test4")==0)
    rv=test_rollback_and_add(databaseUrl, NULL, NULL);

#if 0
  unlink("/tmp/aqdatabase-db1.db");
  rv=test_create_objects("file:///tmp/aqdatabase-db1.db", NULL, "/tmp/aqdatabase-db1.db");
  if (rv) {
    fprintf(stderr, "FAILED: test_create_objects()\n");
    return 2;
  }

  unlink("/tmp/aqdatabase-db1.db");
  rv=test_create_multi("file:///tmp/aqdatabase-db1.db", NULL, "/tmp/aqdatabase-db1.db");
  if (rv) {
    fprintf(stderr, "FAILED: test_create_multi()\n");
    return 2;
  }

  unlink("/tmp/aqdatabase-db1.db");
  rv=test_rollback("file:///tmp/aqdatabase-db1.db", NULL, "/tmp/aqdatabase-db1.db");
  if (rv) {
    fprintf(stderr, "FAILED: test_rollback()\n");
    return 2;
  }

  unlink("/tmp/aqdatabase-db1.db");
  rv=test_rollback_and_add("file:///tmp/aqdatabase-db1.db", NULL, "/tmp/aqdatabase-db1.db");
  if (rv) {
    fprintf(stderr, "FAILED: test_rollback()\n");
    return 2;
  }
#endif


  rv=AQDB_Fini();
  if (rv) {
    DBG_ERROR_ERR(0, rv);
    return 2;
  }

  rv=GWEN_Fini();
  if (rv) {
    DBG_ERROR_ERR(0, rv);
    return 2;
  }


  return 0;
}


